# 
# 
# buevlst.pl
# 
# Innerhalb dieses Perl-Scriptes werden dem Anwender in Abhaengigkeit seiner 
# Eingabe
# weitere Eingabekriterien zu Stichwort und Veranstalter angezeigt.
#
# Aufgerufen wird das Script von buevlst.html
#
#  
# Uebergabeparameter:
#	TRAEGER:	
#		Suchmuster fuer den Veranstalternamen: der Veranstalter bietet den 
# 		Kurs an
#		Synonym verwendet fuer Veranstalter
#	Stichwort:
#		Suchmuster zum Stichwort eines Kurses. Zu einem Kurs koennen 
#		beliebig viele
#		Stichworte hinterlegt sein.
#
#	PLZ:
#		PLZ des gewuenschten Kursortes
# 
#
#			 
#

#
#  die beiden benoetigten Libs einbinden:
#
use Win32::ODBC;	# ODBC-Zugriffe
use CGI;		# CGI-Environment: Variablen abfragen und setzen

$tupelCounter = 0 ;	# Anzahl Tupel, die ein einzelner Select liefert 
$actualTupel = 0;	# Index des aktuell in Bearbeitung befindlichen Tupels


# wir benoetigen einen Pointer auf das CGI-Environment 
$query = new CGI;

# der alias des ODBC-Treibers (symbolischer Name, DSN)
$DSN = "NRWBU_IIS";

  # HTTP-Context setzen

  print "HTTP/1.0 200 OK\n";
  print "Content-type: text/html\n\n";


  # ein neues ODBC-Objekt instantiieren: daisy
  # die Datenbank wird im Erfolgsfalle connected, ansonsten
  # beendet sich die Applikation mit einem kurzen Fehlertext: errData()

  if (!($daisy = new Win32::ODBC($DSN))){
    errData();
  }

  # zunaechst einmal wird das Environment durchsucht: welche Angaben machte der 
  # Anwender ??
  $todo = 0 ;		# steuert die Recherche 
			# siehe einzelne cases

  if($query->param('Stichwort')) {  		# Suche nach STICHWORT 
    $Stichwort = $query->param('Stichwort');
    $todo += 1;
  }

  if($query->param('Traeger')) { 		# Suche nach Veranstalter 
    $Traeger = $query->param('Traeger');
    $todo += 2;
  }

  if($query->param('PLZ')) {     		# Suche nach PLZ 
    $PLZ = $query->param('PLZ');
    $todo += 4;
  }

  # der WherePart des SelectStatements
  $whp = "";

  if ($todo == 0) {				# keine Eingrenzung: Fehler !!
    errData() ;
  }
  #
  # je nach Eingabe wird nun der WherePart bestueckt
  #
  elsif ($todo == 1) {				# nur Stichwort			
    $whp = "WHERE B.STICHWORT LIKE '%" . $Stichwort ."%' ";  
  }
  elsif ($todo == 2) {				# nur Veranstaltername
    $whp = "WHERE A.VER_NAME LIKE '%" . $Traeger ."%' ";  
  }
  elsif ($todo == 3) {				# Name und Stichwort
    $whp  = "WHERE A.VER_NAME LIKE '%" . $Traeger ."%' AND ";
    $whp .= "B.STICHWORT LIKE '%" . $Stichwort ."%' ";    
  } 
  elsif ($todo == 4) {				# nur PLZ
    $whp  = "WHERE A.PLZ LIKE '$PLZ%' ";
  } 
  elsif ($todo == 5) {				# PLZ und Stichwort
    $whp  = "WHERE A.PLZ LIKE '$PLZ%' AND ";
    $whp .= "B.STICHWORT LIKE '%" . $Stichwort ."%' ";    
  } 
  elsif ($todo == 6) {				# Name und PLZ
    $whp  = "WHERE A.VER_NAME LIKE '%" . $Traeger ."%' AND ";
    $whp .= "A.PLZ LIKE '$PLZ%' ";    
  } 
  elsif ($todo == 7) {				# Name, Stichwort und PLZ
    $whp  = "WHERE A.VER_NAME LIKE '%" . $Traeger ."%' AND ";
    $whp .= "B.STICHWORT LIKE '%" . $Stichwort ."%' AND ";    
    $whp .= "A.PLZ LIKE '$PLZ%' ";    
  } 


  # der join der Tabellen adresse und stichwort erfolgt ueber die traegernr	

  $whp .= "AND B.TRAEGERNR = A.TRAEGERNR "; 

  # es gibt bisweilen Probleme mit der Freigabe der Ressourcen von ODBC-Objekten
  # die aus Performance - / oder Optimierungsstrategien nicht freigegeben werden.
  # Der Status SQL_DROP setzt diese Ressourcen frei.

  $daisy->SetStmtCloseType(SQL_DROP);

  # komplettes SQL-Statement aufbauen, sortiert wird ueber den Namen des 
  # Veranstalters

  $sqlStmnt  = "SELECT DISTINCT A.TRAEGERNR AS NR, A.VER_NAME AS NAME ";
  $sqlStmnt .= "FROM ADRESSE A, STICHWORT B ";
  $sqlStmnt .= $whp . " ORDER BY 2";

  # zu Debugzwecken koennte man nun das Statement an dieser Stelle ausgeben 
  # lassen 
  # und in MS-Query beispielsweise testen:
 
  # DEBUG BEGIN
  # print "<H2> $thisWherePart </H2>"; 
  # print "<H2> $sqlStmnt </H2>";
  # print "</body></HTML>\n";
  # $daisy->Close();
  # exit();
  # DEBUG END

  # Das SQL-Statement ausfuehren. Bei Fehlern Datenbank schliessen, Fehlertext 
  # ausgeben und script beenden!

  if($daisy->Sql($sqlStmnt)) {
    $daisy->Close();
    noData();
  }

  # Zwischen Veranstalter und Stichwort besteht eine n:m - Beziehung, daher werden 
  # alle gefundenen Veranstalter und Stichworte innerhalb zweier Vektoren gespeichert 
  # um spaeter im HTML-Dokument eine rudimentaere Pruefung der Relation beider Tabellen zu 
  # ermoeglichen.
  # Die Pruefung erfolgt mittels JavaScript, die verwendete Funktion MakeArray() 
  # benoetigt als Parameter die Anzahl Arrayelemente (sizeOfVeranstalterList und 
  # sizeOfStichwortList).


  $sizeOfVeranstalterList = 0;
  $sizeOfStichwortList = 0;

  # in der folgenden Schleife ueber alle von FetchRow() gelieferten Tupel erfolgt der
  # Zugriff auf die Attribute mittels der methode Data()
  
  while ($daisy->FetchRow() ) {
    ($VER_NR, $NAME) = $daisy->Data("NR", "NAME"); # Zugriff auf die Attribute NR 
						   # und NAME
  
    # Veranstaltername Array mit Index NR speichern und Counter weiterzaehlen.

    $traegerNameList{$VER_NR} = $NAME ;  	   
    $sizeOfVeranstalterList += 1 ;  
  }

  # Datenbank-Cursor schliessen um neuen Select ueber 
  # Stichworte zu preparieren.

  $daisy->DropCursor() ;
   
  # Nachfolgend werden zum jeweils ermittelten Traeger alle Stichworte selektiert
  # und im Vektor StichwortList gespeichert. Die Implementierung erfolgt analog der 
  # Vorgehensweise oben, der WherePart des Statements wird ergaenzt um alle im
  # vorhergehenden Cursor gefundenen TraegerNummern 
  # (... where traegernr in (..., ...) ...)

	.
	.
	.

  # Hier nun erfolgt die Generierung der HTML-Form des folgenden Dialoges


  print "<!-- der Kopf -->\n";
  print "<HTML>\n";
  print "<HEAD>\n";
  print "	<TITLE>Eingrenzung</TITLE>\n";
  print "</HEAD>\n";
  
  # Aufruf der Funktion defineJSFunctions() zur dynamischen Erzeugung des 
  # erforderlichen JavaScript-Codes.
  # Die Funktionen sind weiter unten erlaeutert.

  defineJSFunctions();


  print "<BODY BGCOLOR=\"#FCF5E8\" BACKGROUND=\"/amtfw/frames/gifs/gelb.gif\">\n";
  print "<!-- draft                                            -->\n" ;
  print "<!-- Stephan Hoffmann-Emden 51069 Koeln for AFW 01/97 -->\n";
  print "<!-- s-h-e\@NetCologne.de                              -->\n";
  print "<FORM NAME=\"VERSTW\" METHOD=GET ACTION=\"http://saturn/afwFrameScripts/buKurs4verstw.pl\" target=\"main-02-right\">\n";

  print "<!-- Basistabelle -->\n";
  print "<TABLE CELLSPACING=2 CELLPADDING=2 BORDER=0 WIDTH=\"95%\">\n";

  # versteckte Attribute: COUNTER
  print "<input type=\"hidden\" name=\"COUNTER\" value=\"0\">\n";

  print "<TR>\n";
  print "<TD WIDTH=\"100%\" ALIGN=\"Right\" VALIGN=MIDDLE>\n";
  print "<IMG SRC=\"/amtfw/frames/gifs/urlaub2.gif\" HEIGHT=65 WIDTH=90 BORDER=0  ALT=\"Suche eingrenzen\">\n";
  print "</TD>\n";
  print "</TR>\n";
  print "<TR>\n";
  print "<TD ALIGN=\"Right\" VALIGN=MIDDLE WIDTH=\"100%\">\n";
  print "<FONT FACE=\"ARIAL\"><FONT SIZE=4>\n";
  print "<STRONG>\n";
  print "Weitere Eingrenzung\n";
  print "</STRONG>\n";
  print "</FONT></FONT>\n";
  print "</TD>\n";
  print "</TR>\n";
  print "</TABLE>\n";

  print "<TABLE CELLSPACING=0 CELLPADDING=5 BORDER=0 WIDTH=\"95%\">\n";

  print "<!-- der Traeger -->\n";
  print "<TR>\n";
  print "<TD ALIGN=\"Right\" VALIGN=MIDDLE WIDTH=\"50%\">\n";
  print "<FONT FACE=\"ARIAL\"><FONT COLOR=\"BLUE\" SIZE=3> \n";
  print "Veranstalter:\n";
  print "</FONT></FONT>\n";
  print "</TD>\n";
  print "<TD ALIGN=\"Left\" VALIGN=MIDDLE WIDTH=\"50%\">\n";

  # Hier werden nun die gefundenen Arrayvariablen der Veranstalternamen
  # innerhalb einer DropDownBox ausgegeben.
  # Wenn eine Element neu selektiert wird, erfolgt via handleVeranstalter() eine 
  # rudimentaere Plausibilitaetenpruefung. Der Event hierzu: onChange

  print "<SELECT NAME=\"VERANSTALTER\" onChange=\"handleVeranstalter()\">\n";
  
  # die Moeglichkeit 'keine Eingrenzung' sollte in jedem Fall moeglich sein!

  print "<option selected value=\"00\">keine Eingrenzung</option>\n";  

  foreach $key (sort keys %traegerNameList)  {
    print "<option value=\"$key\">", $traegerNameList{$key}, "</option>\n";
  }
  print "</SELECT>\n";
  print "</TD>\n";
  print "</TR>\n";

  print "<!-- das Stichwort -->\n";

  print "<TR>\n";
  print "<TD ALIGN=\"Right\" VALIGN=MIDDLE WIDTH=\"50%\">\n";
  print "<FONT FACE=\"ARIAL\"><FONT COLOR=\"BLUE\" SIZE=3> \n";
  print "Stichwort:\n";
  print "</FONT></FONT>\n";  
  print "</TD>\n";
  print "<TD ALIGN=\"Left\" VALIGN=MIDDLE WIDTH=\"50%\">\n";

  # Auch hier wieder: Ausgabe der Array-Variablen und Plausibilitaetenpruefung
  # mittels handleStichwort() veranlassen.

  print "<SELECT NAME=\"STICHWORT\" onChange=\"handleStichwort()\">\n";
  print "<option selected value=\"00\">keine Eingrenzung</option>";
  foreach $key (keys %StichwortList)  {
    print "<option value=\"$StichwortList{$key}\">", $key, "</option>\n";
  }
  print "</SELECT>\n";
  print "</TD>\n";
  print "</TR>\n";


  print "<!-- Eingrenzung ueber den Monat -->\n";
  print "<TR>\n";
  print "<TD ALIGN=\"Right\" VALIGN=MIDDLE WIDTH=\"50%\">\n";
  print "<FONT FACE=\"ARIAL\"><FONT COLOR=\"BLUE\" SIZE=3> \n";
  print "Beginn(Monat):\n";
  print "</FONT></FONT>\n";
  print "</TD>\n";
  print "<TD ALIGN=\"Left\" VALIGN=MIDDLE WIDTH=\"50%\">\n";
  print "<SELECT NAME=\"MONAT\">\n";
  print "	<OPTION selected value=\"00\">alle</OPTION> \n";
  print "	<OPTION value=\"01\">Januar</OPTION> \n";
  print "	<OPTION value=\"02\">Februar</OPTION> \n";
  print "	<OPTION value=\"03\">Mrz</OPTION> \n";
  print "	<OPTION value=\"04\">April</OPTION> \n";
  print "	<OPTION value=\"05\">Mai</OPTION> \n";
  print "	<OPTION value=\"06\">Juni</OPTION> \n";
  print "	<OPTION value=\"07\">Juli</OPTION> \n";
  print "	<OPTION value=\"08\">August</OPTION> \n";
  print "	<OPTION value=\"9\">September</OPTION> \n";
  print "	<OPTION value=\"10\">Oktober</OPTION> \n";
  print "	<OPTION value=\"11\">November</OPTION> \n";
  print "	<OPTION value=\"12\">Dezember</OPTION> \n";
  print "</SELECT>\n";
  print "</TD>\n";
  print "</TR>\n";
  print "<!-- ... und die Preisgrenze -->\n";
  print "<TR>\n";
  print "<TD ALIGN=\"Right\" VALIGN=MIDDLE WIDTH=\"50%\">\n";
  print "<FONT FACE=\"ARIAL\"><FONT COLOR=\"BLUE\" SIZE=3> \n";
  print "Preisgrenze:\n";
  print "</FONT></FONT>\n";
  print "</TD>\n";
  print "<TD ALIGN=\"Left\" VALIGN=MIDDLE WIDTH=\"50%\">\n";
  print "<SELECT NAME=\"PREIS\">\n";
  print "	<OPTION selected value=\"00\">egal</OPTION> \n";
  print "	<OPTION value=\"01\">bis  150 ,- DM</OPTION> \n";
  print "	<OPTION value=\"02\">bis  300 ,- DM</OPTION> \n";
  print "	<OPTION value=\"03\">bis  500 ,- DM</OPTION> \n";
  print "	<OPTION value=\"04\">500 ,- DM und mehr</OPTION> \n";
  print "</SELECT>\n";
  print "</TD>\n";
  print "</TR>\n";
  print "<!-- ... sowie Tageszeiten -->\n";

  print "<TR><TD>&#09;</TD><TD>&#09;</TD></TR>\n";
  print "<TR><TD>&#09;</TD><TD>&#09;</TD></TR>\n";

  print "<!-- die obligatorischen Buttons -->\n";
  print "<TR>\n";
  print "<TD ALIGN=\"Right\" VALIGN=MIDDLE WIDTH=\"100%\" COLSPAN=2>\n";
  print "<INPUT TYPE=\"SUBMIT\" NAME=\"Submit\" VALUE=\"Suche starten\">\n";
  print "&nbsp; ";
  print "<INPUT TYPE=\"RESET\" NAME=\"Reset\" VALUE=\"Neue Eingrenzung\">\n";
  print "</TD>\n";
  print "</TR>\n";
  print "<!-- Ende der Basistabelle -->\n";
  print "</TABLE>\n";
  print "<!-- Ende der Form -->\n";
  print "</FORM>\n";

  print "\n";

  print "</BODY>\n";
  print "</HTML>\n";


# Die verwendeten Funktionen

# zunaechst einmal die JavaScript - codes
#

sub defineJSFunctions {

  local $k = 0 ;              


  print "<script LANGUAGE=JavaScript>\n";
  print "\n";
  print "<!--\n";
  print "\n";
  print "// Listen fuer stichwort und veranstalter\n"; # Kommentare in JavaScript: // 
  print "\n";
  
  #
  # MakeArray() fuer beide Listen aufrufen:
  #
  $k = $sizeOfVeranstalterList + 1;        # ein Eintrag zusaetzlich fuer 'keine Eingrenzung'   
  print "veranstalterList = new MakeArray($k) \n";
  $k = $sizeOfStichwortList + 1;
  print "stichwortList    = new MakeArray($k) \n";

  #
  # Werte fuer alle Veranstalter im JavaScript Array hinterlegen: 
  #
  print "veranstalterList[\"00\"] = \"00-keine Eingrenzung\" \n";
  foreach $key (keys %traegerNameList)  {
    print "veranstalterList[\"$key\"] = \"$key-$traegerNameList{$key}\" \n";
  }
  
  print "\n";

  #
  # das gleiche procedere fuer Stichwort 
  #

  print "stichwortList[\"00-keine Eingrenzung\"] = \"keine Eingrenzung\" \n";
  foreach $key (keys %StichVer) {
    print "stichwortList[\"$key\"] = \"$StichVer{$key}\" \n";
  }

  print "\n";

  # die folgenden JavaScript Codes pruefen wechselseitig, ob ein Veranstalter
  # einen Eintrag fuer ein gefundenens Stichwort beinhaltet, oder umgekehrt, ein
  # gewaehltes Stichwort fuer den jeweils selektierten Veranstalter gueltig ist.
  # Die Funktionen durchlaufen den jeweiligen Vector, die Pruefung erfolgt
  # ueber die TraegerNr
  #
  print "// Funktionsdefinitionen fuer check-routinen der form-daten:\n";
  
  # getVeranstalterIdx() liefert aktuell gewaehlten Index

  print "function getVeranstalterIdx() \n";
  print "{\n";
  print "    return document.VERSTW.VERANSTALTER.selectedIndex\n";
  print "}\n";
  print "\n";

  # getVeranstalterValue() liefert den Wert des selektierten Listenelementes

  print "function getVeranstalterValue() \n";
  print "{\n";
  print "   return document.VERSTW.VERANSTALTER.options[getVeranstalterIdx()].value\n";
  print "}\n";
  print "\n";
  
  # getStichwortIdx() s. Veranstalter

  print "function getStichwortIdx() \n";
  print "{\n";
  print "      return document.VERSTW.STICHWORT.selectedIndex\n";
  print "}\n";
  print "\n";

  # getStichwortValue() s. Veranstalter

  print "function getStichwortValue() \n";
  print "{\n";
  print "      return document.VERSTW.STICHWORT.options[getStichwortIdx()].value\n";
  print "}\n";
  print "\n";

  print "// Test, ob Veranstalter fuer Stichwort gueltig ist:\n";
  print "\n";

  print "function veranstalterHasStichwort(Veranstalter, Stichwort)\n";
  print "{\n";
  print "  var thisStichwort = Stichwort\n";
  print " \n";
  print "  var idx = Veranstalter + \"-\"\n";
  print "\n";
  print "   idx += thisStichwort   \n";
  print "  \n";
  print "  for(i in stichwortList) {\n";
  print "      if (i  == idx) {\n";
  print "        return true\n";
  print "      }  \n";
  print "  }\n";
  print "\n";
  print "  return false\n";
  print "}\n";
  print "\n";
  print "\n";


  print "// Stichwort fuer Veranstalter ermitteln:\n";
  print "// Die Variable hat den Aufbau: [Index]-[Name],\n";
  print "// die Werte muessen extrahiert werden.\n";
  print "\n";

  print "function stichwortForVeranstalter(Veranstalter)\n";
  print "{\n";
  print "  var returnValue = \"\"\n";
  print "  var myPos = 0\n";
  print "  var myVeranstalter = \"\"\n";
  print "  var myIdx = \"\"\n";
  print "  var i = \"\"\n";
  print "  \n";
  print "\n";
  print "  myVeranstalter = Veranstalter\n";
  print "  \n";
  print "  for(i in stichwortList) {\n";
  print "     myPos = i.indexOf(\"-\")\n";
  print "     myIdx = i.substring(0, myPos)\n";
  print "\n";
  print "     if (myIdx == myVeranstalter) {\n";
  print "        returnValue += stichwortList[i] + \"\\n\"\n";
  print "      }  \n";
  print "  }\n";
  print "\n";
  print "  return returnValue\n";
  print "}\n";
  print "\n";
  print "\n";
  
  print "// Veranstalter fuer Stichwort ermitteln:\n";
  print "\n";

  print "function veranstalterForStichwort(Stichwort)\n";
  print "{\n";
  print "  var returnValue = \"\"\n";
  print "  var myPos = 0\n";
  print "  var myVeranstalter = \"\"\n";
  print "  var myBuffer = \"\"\n";
  print "  var myIdx = \"\"\n";
  print "  var i = \"\"\n";
  print "  var verIdx = 0\n";
  print "\n";
  print "  \n";
  print "  for(i in stichwortList) {\n";
  print "     myPos  = i.indexOf(\"-\") \n";
  print "     verIdx = i.substring(0, myPos)\n";
  print "     \n";
  print "     myPos++  \n";
  print "     myIdx = i.substring(myPos, i.length)\n";
  print "\n";
  print "     if (myIdx == Stichwort) {\n";
  print "        myBuffer = veranstalterList[verIdx] \n";
  print "        myPos  = myBuffer.indexOf(\"-\") \n";
  print "        myPos++\n";
  print "        myVeranstalter = myBuffer.substring(myPos, myBuffer.length)\n";
  print "        returnValue += myVeranstalter + \"\\n\"\n";
  print "      }  \n";
  print "  }\n";
  print "\n";
  print "  return returnValue\n";
  print "}\n";
  print "\n";
 
  print "\n";
  print "\n";
 

  print "// EventHandler fuer Veranstalterdaten:\n";
  print "\n";

  print "function handleVeranstalter()\n";
  print "\n";
  print "{\n";
  print "  var thisStichwort = getStichwortValue()\n";
  print "  var thisVeranstalter = getVeranstalterValue()\n";
  print "  var thisStwList = \"\"\n";
  print "\n";
  print "  if ((getVeranstalterIdx() > 0) && (getStichwortIdx() > 0)) {\n";
  print "    if (veranstalterHasStichwort(thisVeranstalter, thisStichwort) != true){\n";
  print "       thisStwList = stichwortForVeranstalter(thisVeranstalter)\n";
  print "       alert(\"\\tDas Stichwort '\" + thisStichwort + \n";
  print "             \"'\\n\\texistiert nicht\\n\\tfr den gewhlten Veranstalter.\" + \n";
  print "             \"\\n\\tBitte whlen Sie eines der folgenden:\\n\" + thisStwList)\n";
  print "    }\n";
  print "  }\n";
  print " \n";
  print "   return true\n";
  print "}\n";
  print "\n";

  print "// EventHandler fuer Stichwort-Eintraege\n";
  print "\n";

  print "function handleStichwort()\n";
  print "\n";
  print "{\n";
  print "  var thisStichwort = getStichwortValue()\n";
  print "  var thisVeranstalter = getVeranstalterValue()\n";
  print "  var thisVerList = \"\"\n";
  print "\n";
  print "   if ((getVeranstalterIdx() > 0) && (getStichwortIdx() > 0)) {\n";
  print "    if (veranstalterHasStichwort(thisVeranstalter, thisStichwort) != true){\n";
  print "      thisVerList = veranstalterForStichwort(thisStichwort)\n";
  print "      alert(\"\\tDas Stichwort '\" + thisStichwort + \n";
  print "            \"'\\n\\texistiert nicht\\n\\tfr den gewhlten Veranstalter.\" \n";
  print "            + \"\\nBitte whlen Sie aus der Liste:\\n\" + thisVerList  )\n";
  print "    }\n";
  print "  }\n";
  print "    \n";
  print "   return true \n";
  print "}\n";
  print "\n";
  print "\n";
  print "\n";

  # Die Funktion MakeArray()

  print "function MakeArray(n)\n";
  print "{\n";
  print "  this.length = n \n";
  print "\n";
  print "  for (var i = 0; i < n; ++i) {\n";
  print "    this[i] = 0\n";
  print "  }\n";
  print "  return this \n";
  print "}\n";
  print "\n";
  print "\n";
  print "// -->\n";

  # Ende des JavaScript-Codes

  print "</script>\n";

}


# Ausgaberoutinen im Fehlerfalle: noData und errData


sub noData {
  print "<HTML>\n";
  print "<HEAD>\n";
  print "	<TITLE>Systemfehler</TITLE>\n";
  print "</HEAD>\n";
  print "\n";
  print "<BODY BGCOLOR=\"#FCF5E8\" BACKGROUND=\"/amtfw/frames/gifs/gelb.gif\" BGPROPERTIES=\"FIXED\">\n";
  print "<TABLE CELLSPACING=2 CELLPADDING=2 BORDER=0 WIDTH=60%>\n";
  print "<TR>\n";
  print "<TD WIDTH=\"100%\" ALIGN=\"Right\" VALIGN=MIDDLE>\n";
  print "<IMG SRC=\"/amtfw/frames/gifs/urlaub2.gif\" WIDTH=90 HEIGHT=65 BORDER=0  ALT=\"Kurssuche\">\n";
  print "</TD>\n";
  print "</TR>\n";
  print "<TR>\n";
  print "<TD ALIGN=\"Right\" VALIGN=MIDDLE WIDTH=\"100%\">\n";
  print "<FONT FACE=\"ARIAL\">\n";
  print "<FONT SIZE=4>\n";
  print "<STRONG>\n";
  print "Keine Kurse vorhanden \n";
  print "</STRONG>\n";
  print "</FONT>\n";
  print "</FONT>\n";
  print "</TD>\n";
  print "</TR>\n";
  print "</TABLE>\n";
  print "<TABLE CELLSPACING=0 CELLPADDING=5 BORDER=0 WIDTH=60%>\n";
  print "<!-- need more empty lines -->\n";
  print "<TR>\n";
  print "<TD ALIGN=\"Left\" VALIGN=MIDDLE WIDTH=\"50%\">\n";
  print "&nbsp;\n";
  print "</TD>\n";
  print "<TD ALIGN=\"Left\" VALIGN=MIDDLE WIDTH=\"50%\">\n";
  print "&nbsp;\n";
  print "</TD>\n";
  print "</TR>\n";
  print "<!-- message -->\n";
  print "<TR>\n";
  print "<TD ALIGN=\"Right\" VALIGN=MIDDLE COLSPAN=2 WIDTH=\"100%\">\n";
  print "<FONT FACE=\"ARIAL\">\n";
  print "<FONT COLOR=\"BLUE\" SIZE=3>\n";
  print "Es konnten keine Kurse ermittelt werden, die Ihren Suchkriterien entsprechen.\n";
  print "</FONT>\n";
  print "</FONT>\n";
  print "</TD>\n";
  print "</TR>\n";
  print "<TR>\n";
  print "<TD ALIGN=\"Right\" VALIGN=MIDDLE COLSPAN=2 WIDTH=\"100%\">\n";
  print "<FONT FACE=\"ARIAL\">\n";
  print "<FONT COLOR=\"BLUE\" SIZE=3>\n";
  print "Bitte starten Sie Ihre Anfrage mit neuen Suchkriterien.\n";
  print "</FONT>\n";
  print "</FONT>\n";
  print "</TD>\n";
  print "</TR>\n";
  print "<TR>\n";
  print "<TD ALIGN=\"Left\" VALIGN=MIDDLE WIDTH=\"50%\">\n";
  print "&nbsp;\n";
  print "</TD>\n";
  print "<TD ALIGN=\"Left\" VALIGN=MIDDLE WIDTH=\"50%\">\n";
  print "&nbsp;\n";
  print "</TD>\n";
  print "</TR>\n";
  print "<!-- Buttons -->\n";
  print "<TR>\n";
  print "<TD ALIGN=\"Right\" VALIGN=MIDDLE WIDTH=\"100%\" COLSPAN=2>\n";
  print "<A HREF=\"http://saturn/amtfw/frames/frmeMain05.html\" target=\"main-02-right\">\n";
  print "<IMG SRC=\"/amtfw/frames/gifs/zurueck.gif\" WIDTH=10 HEIGHT=20 BORDER=0\">\n";
  print "</A>\n";
  print "</TD>\n";
  print "</TR>\n";
  print "<!-- end of main table -->\n";
  print "</TABLE>\n";
  print "</HTML>\n";

  exit() ;
}


sub errData {

# Fehlerausgabe
	.
	.
	.

  exit() ;
}

