# 
# 
# nrwbythemes.pl
# Perl-script for gettin' detail-data of NRWBU_IIS
# 
# Innerhalb dieses Perl-Scriptes werden dem Anwender jeweils bis zu 8 (countAtOnce)
# Kurse angezeigt.
#
# saturn ist der servername des Testsystems
#  
# Uebergabeparameter:
#	VER_NR:	
#		die Veranstalter-Nr: der Veranstalter bietet den Kurs an
#		der Veranstalter wurde in einem bergeordneten HTML-Dialog (Form) bereits 
#		ausgewaehlt.
#
#	LEVEL_1
#	LEVEL_2:	 
#  		Das gewuenschte Themenlevel zum Kurs, auch dieses wurde in einer 
#		vorangestellten Form ermittelt.
#
#	COUNTER:
#		Parameter, der die bereits bearbeitete Anzahl an Tupeln beinhaltet
#		Wenn mehr als countAtOnce (8) Tupel das ERgebnis eines Selects sind,
#		so wird ueber diese Variable in der Ergebnismenge gescrollt.
#	beginn_mon:
#		Der Monat, an dem der Kurs beginnen soll. Dieser Parameter ist wahlfrei,
# 		VER_NR und LEVEL_1, LEVEL_2 und COUNTER muessen zur Eingrenzung bekannt sein.
#
# 
#
#
# draft:
# author:	date:	 reason:	 
# she 		18-01-97 implemented
#
#
#  die beiden benoetigten Libs einbinden:
#
use Win32::ODBC;	# ODBC-Zugriffe
use CGI;		# CGI-Environment: Variablen abfragen und setzen

$countAtOnce = 8;  	# max. Anzahl Tupel pro Anfrage
$tupelCounter = 0 ;	# Anzahl Tupel, die ein einzelner Select liefert 
$actualTupel = 0;	# Index des aktuell in Bearbeitung befindlichen Tupels
$countForTupel = 0;	# Anzahl zu ueberlesender Tupel (scrollen)


# wir benoetigen einen Pointer auf das CGI-Environment 
$query = new CGI;

# der alias des ODBC-Treibers (symbolischer Name der DNS)
$DSN = "NRWBU_IIS";

  # diese Zeilen liefern den passenden HTML-header in Abhaengigkeit davon,
  # ob PERL-IS oder PERL.EXE im Einsatz ist. Die EnvironmentVariable PERLXS hilft
  # hier weiter.

  if($ENV{'PERLXS'} eq 'PerlIS')  # manually set HEADER
  {
    print "HTTP/1.0 200 OK\n";
    print "Content-type: text/html\n\n";
  }
  else {
    print "\n\n" ;
  }


  # ein neues ODBC-Objekt instantiieren: nrw
  # die Datenbank wird im Erfolgsfalle connected, ansonsten
  # beendet sich die Applikation mit einem kurzen Fehlertext: errData

  if (!($nrw = new Win32::ODBC($DSN))){
    &errData();				
  }

  # es gibt bisweilen Probleme mit der Freigabe der Ressourcen von ODBC-Objekten
  # die aus Performance - / oder Optimierungsstrategien nicht freigegeben werden.
  # Der Status SQL_DROP setzt diese Ressourcen frei.

  $nrw->SetStmtCloseType(SQL_DROP);

  # Nun wird die ERgebnismenge des Selects definiert. Dieser Teil des
  # Statements ist statisch:
  # die Konkatenation von Strings erfolgt in Perl durch .
  #
  $sqlStmnt = "SELECT A.TRAEGERNR as VER_NR, A.VER_NAME as VER_NAME, "; 
  $sqlStmnt = $sqlStmnt . "B.THEMA as KURS_THEMA, B.INHALT as KURS_BESCH, ";
  #
  # die Unterstuetzung von aggregat-functions ist nicht immer gewaehrleistet!
  #
  $sqlStmnt = $sqlStmnt . "B.DATUMZUSATZ, DAY(B.KURSBEGINN) as BEGINN_DAY, ";
  $sqlStmnt = $sqlStmnt . "MONTH(B.KURSBEGINN) as BEGINN_MON, ";
  $sqlStmnt = $sqlStmnt . "YEAR(B.KURSBEGINN) as BEGINN_YEAR, ";
  $sqlStmnt = $sqlStmnt . "DAY(B.KURSENDE) as ENDE_DAY, MONTH(B.KURSENDE) as ENDE_MON, ";
  $sqlStmnt = $sqlStmnt . "YEAR(B.KURSENDE) as ENDE_YEAR, ";
  $sqlStmnt = $sqlStmnt . "A.STRASSE, A.ORT as ORT, B.KURSORT, ";
  $sqlStmnt = $sqlStmnt . "A.PLZ, ";
  $sqlStmnt = $sqlStmnt . "B.PREIS as PREIS, B.PREISTXT as PREISTXT, ";
  $sqlStmnt = $sqlStmnt . "B.DATUMZUSATZ as DATUMZUSATZ, B.KENNTNISSE as KENNTNISSE, ";
  $sqlStmnt = $sqlStmnt . "A.VORWAHL AS VORWAHL, A.TELEFON AS TELEFON, ";
  $sqlStmnt = $sqlStmnt . "A.FAX AS FAX, A.KONTAKT AS KONTAKT ";
  $sqlStmnt = $sqlStmnt . "FROM ADRESSE A, NRWBU1 B ";

  # der wherepart wird in Abhaengigkeit des Environments bestimmt !

  $thisWherePart = &buildWherePart();  # zu debug-zwecken

  # endgueltigen select formulieren: 
  # select-clausel, where-clause, order-clause
  #
  $sqlStmnt = $sqlStmnt . $thisWherePart. buildOrderPart();

  # zu DEBUG-Zwecken im Net sind diese Zeilen oft nuetzlich gewesen.
  # Das Statement laesst sich so einfach ueberpruefen, in die Zwischenablage
  # kopieren und, etwa mit MSQuery auf der Datenbank ausfuehren.
  #
 # DEBUG BEGIN
 # print "<H2> $thisWherePart </H2>"; 
 # print "<H2> $sqlStmnt </H2>";
 # print "</body></HTML>\n";
 # $nrw->Close();
 # exit();
 # DEBUG END
 #
 #
 # Das SQL-Statement ausfuehren. Bei Fehlern Datenbank schliessen und kurzen Text ausgeben!

  if($nrw->Sql($sqlStmnt)) {
    $nrw->Close();
    &noData();
  }

  #
  # Die Funktion RowCount() aus dem ODBC-Paket lieferte keine korrekten Ergebnisse,
  # die Ausfuehrung ist abhaengig vom verwendeten Treiber. Auch count(*)
  # brachte keine brauchbaren Ergebnisse, daher werden die Tupel mal eben schnell
  # manuell gezaehlt. Funktioniert auch!!

  for($tupelCounter = 0; ; $tupelCounter++) {
    last if (! $nrw->FetchRow());
  }

  # wenn's keine Daten gibt, kurzen text ausgeben!
  #

  if($tupelCounter == 0) {
    $nrw->Close();
    &noData();
  }

  $nrw->DropCursor(); 		# Cursor zuruecksetzen fuer eigentliche Abfrage

  if($nrw->Sql($sqlStmnt)) { 	# siehe oben
    $nrw->Close();
    &noData();
  }

  # HTML-Header der Ergebnis-Seite ausgeben!

  print "<html>\n<head>\n";
  print "<title>Kursangebot</title>\n";
  print "</head>\n";

  # ganz normaler HTML-Code, in print - statement verpackt!

  print "<body background=\"/gifs/backgrd.gif\">\n";
  print "<div align=center>\n";
  print "<center>\n";
  print "<table cellpadding=0 width=570>\n";
  print "<tr><td width=66%><font FACE=\"ARIAL\"><font size=2>\n";
  print "<b>Amt f&uuml;r Weiterbildung</font></font></b></font></td>\n";
  print "<td align=right valign=top width=33%><font FACE=\"ARIAL\">\n";
  print "<font size=2><b>Ihre Kurs-Anfrage lieferte ", $tupelCounter;

  if($tupelCounter > 1) {
    print " Kurse!";
  }
  else  {
    print " Kurs!";
  }

  print "</font></b></font></td></tr>\n";
  print "</table>\n"; 
  print "</center>\n";
  print "</div>\n";

  # Hier findet nun die Ausgabe der Query-details statt!
  # Beim Scrolling werden 'einfach' n Tupel ueberlesen.
  # Eine Alternative waere etwa, Bookmarks in EINEM Dokument zu setzen und jeweils
  # einen Link auf die naechste hoehere Marke zu setzen
  # Die Anzahl bisher gezeigter Kursangebote (Tupel) ist in COUNTER definiert.
  #

  # So einfach gestaltet sich der Zugriff auf die Environment-Variable COUNTER!
  #
  $countForTupel = $query->param('COUNTER');

  # Alle Tupel lesen bis 

  for($actualTupel = 0; $actualTupel < $countForTupel; $actualTupel++)  {
    last if (! $nrw->FetchRow());  	# break, wenn Methode FetchRow kein Tupel liefert
  }

  for($i = 0; $i < $countAtOnce ; $i++, $actualTupel++) {
 
    last if (! $nrw->FetchRow()); 

    # Die in der Ergebnismenge gelieferten Datenbankwerte in einer Liste von
    # normalen Perl-Variablen verarbeiten.
    # Rueckgabewert von Data() ist eine Liste 
    #
    ($VER_NR, $VER_NAME, $KURS_THEMA, $KURS_BESCH) = $nrw->Data("VER_NR", "VER_NAME", "KURS_THEMA", "KURS_BESCH");
    ($DATUMZUSATZ, $BEGINN_DAY, $BEGINN_MON) = $nrw->Data("DATUMZUSATZ", "BEGINN_DAY", "BEGINN_MON");
    ($BEGINN_YEAR, $ENDE_DAY, $ENDE_MON) = $nrw->Data("BEGINN_YEAR", "ENDE_DAY", "ENDE_MON");
    ($ENDE_YEAR, $STRASSE, $ORT, $KURSORT, $PLZ) = $nrw->Data("ENDE_YEAR", "STRASSE", "ORT", "KURSORT", "PLZ");
    ($PREIS, $PREISTXT, $DATUMZUSATZ, $KENNTNISSE) = $nrw->Data("PREIS", "PREISTXT", "DATUMZUSATZ", "KENNTNISSE");
    ($VORWAHL, $TELEFON, $FAX, $KONTAKT) = $nrw->Data("VORWAHL", "TELEFON", "FAX", "KONTAKT");

    # die Variablen in HTML-Code verpackt ausgeben
    #
    print "<table cellpadding=0 width=95%>\n";
    print "<tr>\n";
    print "<td align=center>\n";
    print "<a href=\"http://saturn/afw.htm\">";
    print "<img src=\"/gifs/neu-10.jpg\" align=bottom width=42 height=42 border=0>\n";
    print "</a>\n";
    print "</td>\n";
    print "</tr>\n";
    print "</table>\n";
    print "<div align=center><center>\n";
    print "<table cellpadding=0 width=570>\n";
    print "<tr>\n";
    print "<td valign=top width=50%><font FACE=\"ARIAL\"><font size=2><b>";
    print "Veranstalter:</b></font></font>\n";
    print "</td>\n";
    print "<td valign=top width=50%><font FACE=\"ARIAL\"><font size=2><b>Ansprechpartner:</b></font></font>\n";
    print "</td>\n";
    print "</tr>\n";
    print "<tr>\n";
    print "<td valign=top width=50%><font FACE=\"ARIAL\"><font size=2>", $VER_NAME, "<br>", $STRASSE, " ", $PLZ, " ", $ORT, "</font></font>\n";
    print "</td>\n";
    print "<td valign=top width=50%><font FACE=\"ARIAL\"><font size=2>";
    print "$KONTAKT <br>";
    if ($TELEFON ne "")  {
      print "Tel.: ";
      if ($VORWAHL != 0)  {
        print "$VORWAHL - ";
      }
      print $TELEFON ;
    }
    
    if ($FAX ne "")  {
      print ", Fax: $FAX";
    }

    print "</font></font>\n";
    print "</td>\n";
    print "</tr>\n";
    print "</table>\n";
    print "</center>\n";
    print "</div>\n";
    print "<p align=center><font size=2><img src=\"/gifs/blue_line.gif\" align=bottom> </font>\n";
    print "</p>\n";
    print "<div align=center><center>\n";
    print "<table cellpadding=0 width=570>\n";
    print "<tr>\n";
    print "<td valign=top width=10%><font FACE=\"ARIAL\"><font size=2><b>Trg-Nr.: </b><br>";
    print $VER_NR, "  </font></font></font>\n";
    print "</td>\n";
    print "<td width=85%><font FACE=\"ARIAL\"><font size=2>";
    print $KURS_THEMA, "</font></font>\n";
    print "</td>\n";
    print "</tr>\n";
    print "</table>\n";
    print "</center>\n";
    print "</div>\n";
    print "<p align=center><font size=2><b><img src=\"/gifs/blue_line.gif\" align=bottom> </b></font></p>\n";
    print "<div align=center><center>\n";
    print "<table cellpadding=0 width=570>\n";
    print "<tr>\n";
    print "<td valign=top width=10%><font FACE=\"ARIAL\"><font size=2><b>Inhalt:</font></b></font>\n";
    print "</td>\n";
    print "<td width=85%><font FACE=\"ARIAL\"><font size=2>";
    print $KURS_BESCH, "</font></font>\n";
    print "</td>\n";
    print "</tr>\n";
    print "</table>\n";
    print "</center></div>\n";
    print "<p align=center><font size=2><img src=\"/gifs/blue_line.gif\" align=bottom> </font></p>\n";
    print "<div align=center><center>\n";
    print "<table cellpadding=0 width=570>\n";
    print "<tr>\n";
    print "<td width=50%><font FACE=\"ARIAL\"><font size=2>";
    if($KURS_ORT ne "")  {  
      print "<b>Kursort:</b>";
      print "</font></font>\n";
      print "<p><font size=2>", $KURS_ORT, "</font></p>\n";
    }
    else {
      print "<b>Kursort nicht angegeben!</b></font></font>\n";
    }
    print "</td></tr>\n";

    print "<tr>";

    if($BEGINN_YEAR) {
      print "<td valign=top width=50%><font FACE=\"ARIAL\"><font size=2><b>Kursbeginn:</b></font></font>\n";
      print "<p><font size=2><font FACE=\"ARIAL\">", $BEGINN_DAY, ".", $BEGINN_MON, ".", $BEGINN_YEAR, "</font></font></p>\n";
      print "</td>\n";
    }

    if($ENDE_YEAR) {
      print "<td valign=top width=50%><font FACE=\"ARIAL\"><font size=2><b>Kursende:</b></font></font>\n";
      print "<p><font size=2><font FACE=\"ARIAL\">", $ENDE_DAY, ".", $ENDE_MON, ".", $ENDE_YEAR, "</font></font></p>\n";
      print "</td>\n";
    }

    print "</tr>\n";
    print "</table>\n";
    print "</center>\n";
    print "</div>\n";
    print "<div align=center>\n";
    print "<center>\n";
    print "</td>\n";

    print "<table cellpadding=0 width=570>\n";
    print "<td valign=top width=50%><font FACE=\"ARIAL\"><font size=2>";

    if($DATUMZUSATZ ne "") {
      print "<b>Hinweis: </b>";
      print $DATUMZUSATZ;
    } 

    print "</font></font>\n";
    print "</td>\n";

    print "<td valign=top width=50%><font FACE=\"ARIAL\"><font size=2>";

    if($PREIS > 0) {
      print "<b>Preis: </b>";
      print "$PREIS DM";
    } 

    print "</font></font>\n";
    print "</td>\n";

    print "<td valign=top width=50%><font FACE=\"ARIAL\"><font size=2>";

    if($PREISTXT ne "") {
      print " $PREISTXT";
    } 

    print "</font></font>\n";
    print "</td>\n";

    print "</tr>";

    if($KENNTNISSE ne "") {  
      print "<tr>\n";
      print "<td valign=top width=50%><font FACE=\"ARIAL\"><font size=2>";
      print "<b>Kenntnisse: </b>", $KENNTNISSE, "<br>";
      print "</font></font>\n";
      print "</td>\n";
      print "</tr>\n";
    }

    print "</table>\n";
    print "</center>\n";
    print "</div>\n";

  }  # for alle Tupel

  print "<p align=center><font size=2><br>\n";
  print "<table cellpadding=0 width=95%>\n";
  print "<tr>\n";
  
  # Wenn mehr als countAtOnce Kurse gefunden werden, dann soll erneut dieses Script
  # aufgerufen werden.
  # Zu diesem Zweck soll die Environment-Variable COUNTER mit derm aktuellen 
  # Wert belegt werden!
  # Dies erledigt die Methode self_url()
  # Vorher wird der Variablen COUNTER der neie Wert zugewiesen!
  #
  if($actualTupel < $tupelCounter) {
    print "<td width=33% align=right>\n";
    print "<font size=2>";
    # setze Parameter COUNTER
    $i = $countForTupel + $actualTupel;
    $query->param('COUNTER', $i);
    #
    # anchor mit der eigenen URL und dem neuen Paramater COUNTER
    # setzen!!
    #
    print "<a href=\"". $query->self_url . "\">";  
    print "<img src=\"/gifs/weiter.gif\" align=bottom width=32 height=31 border=0></a>";
    print "</font>\n";
    print "</td>";
  }
  print "<td width=33% align=center>";
  print "<font size=2>\n";
  print "<a href=\"http://saturn/nrwstart.htm\">\n";
  print "<img src=\"/gifs/book_index.gif\" align=bottom width=32 height=31 border=0>";
  print "</a>\n";
  print "</font>\n";
  print "</td>";
  print "<td width=33% align=left>";
  print "<font size=2> \n";
  print "<a href=\"http://saturn/afw.htm\">";
  print "<img src=\"/gifs/neu-10.jpg\" align=bottom width=32 height=31 border=0>\n";
  print "</a>\n";
  print "</font>\n";
  print "</td>\n";
  print "</tr>\n";
  print "</table>\n";
  print "</p>\n";
  print "</body>\n";
  print "</html>\n";

  # Datenbank schliessen!

  $nrw->Close();
  
# Ende der Hauptroutine

##############################################################################
#
# Implementation der Funktionen

# Die where-clause in Abhaengigkeit des Environments ausbilden!
# 
sub buildWherePart {
  local $monatIdx = 0;		# Hilfsvariablen zum Aufbau der where-clause
  local $timeIdx = 0;
  local $wherePart = " where ";	# lokaler String 
  local $firstOne = 1;		# Hilfsvariable, steuert setzen von 'AND'

  if ($query->param) {	# wenn es einen Pointer aufs Environment gibt,
			# dann alle Variablen bestimmen und wherePart bestuecken
    if($query->param('VER_NR')) { 
      $VER_NR = $query->param('VER_NR');
    }

    if($query->param('LEVEL_1')) { 
      $LEVEL_1 = $query->param('LEVEL_1');
    }

    if($query->param('LEVEL_2')) { 
      $LEVEL_2 = $query->param('LEVEL_2');
    }


    # diese Attribute sind immer gesetzt
    #	
    $firstOne = 0;
    $wherePart = $wherePart . "A.TRAEGERNR = $VER_NR ";
    $wherePart = $wherePart . "AND B.TH_LEV_1 = $LEVEL_1 ";
    $wherePart = $wherePart . "AND B.TH_LEV_2 = $LEVEL_2 ";

  
    # bei Bedarf Beginnmonat eingrenzen
    # 
    if($query->param('beginn_mon')) { # BeginnMonat
      $monatIdx = $query->param('beginn_mon');      
      if($monatIdx > 0) {
        if($firstOne == 0)  {
          $wherePart = $wherePart . " AND ";
        }
        $wherePart = $wherePart . " MONTH(B.KURSBEGINN) >= " . $monatIdx . " "; 
        $firstOne = 0;
      }
    }
    
    if($firstOne == 1)  {
      $wherePart = $wherePart . " AND ";
    }
  } # there's an ENV   
  
  # Die Relation ueber den Schluessel TRAEGERNR ist immer gegeben.
  #   
  $wherePart = $wherePart . "AND A.TRAEGERNR = B.TRAEGERNR ";

  # Den String als Returnwert zurueckliefern
  #

  return $wherePart ;

}

# Order by liefern! 
  
sub buildOrderPart {
  local $orderPart = " ORDER BY 7, 8";
 
  return $orderPart;

} 

# kurze Hilfsroutine zur Statusmitteilung!
#
sub  noData  {
  print "<html>\n<head>\n";
  print "<title>DB-Anfrage NRW</title>\n";
  print "</head>\n";

  print "<body background=\"/gifs/backgrd.gif\">\n";
  print "<div align=center>\n";


  print "<H5>Achtung!! Es wurden keine Daten zur Suchanfrage gefunden!!</H5>\n";

  print "<p align=center><font size=2><br>\n";
  print "<table cellpadding=0 width=95%>\n";
  print "<tr>\n";

  print "<td width=50% align=right>";
  print "<font size=2>\n";
  print "<a href=\"http://saturn/nrwstart.htm\">\n";
  print "<img src=\"/gifs/book_index.gif\" align=bottom width=32 height=31 border=0>";
  print "</a>\n";
  print "</font>\n";
  print "</td>";
  print "<td width=50% align=left>";
  print "<font size=2> \n";
  print "<a href=\"http://saturn/afw.htm\">";
  print "<img src=\"/gifs/neu-10.jpg\" align=bottom width=32 height=31 border=0>\n";
  print "</a>\n";
  print "</font>\n";
  print "</td>\n";
  print "</tr>\n";
  print "</table>\n";
  print "</p>\n";
  print "</body>\n";
  print "</html>\n";


  exit();

}

# Fehlermeldung ausgeben!
#
sub  errData  {
  print "<html>\n<head>\n";
  print "<title>DB-Anfrage NRW</title>\n";
  print "</head>\n";

  print "<body background=\"/gifs/backgrd.gif\">\n";
  print "<div align=center>\n";

  print "<H5>Achtung! Das System konnete Ihre Anfrage nicht bearbeiten!</H5>\n";
  print "<H5>Bitte starten Sie eine neue Anfrage!</H5>\n";
  print "<p align=center><font size=2><br>\n";
  print "<table cellpadding=0 width=95%>\n";
  print "<tr>\n";

  print "<td width=50% align=center>";
  print "<font size=2> \n";
  print "<a href=\"http://saturn/afw.htm\">";
  print "<img src=\"/gifs/neu-10.jpg\" align=bottom width=32 height=31 border=0>\n";
  print "</a>\n";
  print "</font>\n";
  print "</td>\n";
  print "</tr>\n";
  print "</table>\n";
  print "</p>\n";
  print "</body>\n";
  print "</html>\n";

  exit();

}

